package com.xinwangdao.CompanyStatistical.component;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.ToString;

import java.util.HashMap;
import java.util.Map;

/**
 * 异常枚举
 *
 * @Author: zthu
 * @Date: 2021-06-15
 */
@Getter
@ToString
public enum GlobalException {
    UNKNOWN_ERROR(-1L, "未知错误"),

    /*** permission ***/
    ACCESS_DENIED(1000L, "拒绝访问"),

    /*** request ***/
    REQUEST_PARAMS_INVALID(2000L, "请求参数错误"),

    /*** user ***/
    USER_PASSWORD_INVALID(3000L, "密码错误"),
    USER_NOT_EXIST(3001L, "用户不存在"),
    USER_NOT_LOGIN(3002L, "用户未登录"),
    USER_ALREADY_LOGIN(3003L, "用户已经登录,请勿重复登录"),
    USER_PERMISSION_DENIED(3100L, "用户权限不足"),

    /*** DB ***/
    DB_DUPLICATE_KEY(5001L, "记录已存在");


    private final Long code;
    private final String desc;

    GlobalException(Long errorCode, String errorMsg) {
        this.code = errorCode;
        this.desc = errorMsg;
    }

    public static Map getAllType() {
        HashMap<String, String> map = new HashMap<String, String>();
        for (GlobalException item : GlobalException.values()) {
            map.put(String.valueOf(item.code), item.desc);
        }
        return map;
    }
	
	public GlobalRunTimeException ex() {
        return new GlobalRunTimeException(this);
    }

    @Getter
    @AllArgsConstructor
    public class GlobalRunTimeException extends RuntimeException {
        private GlobalException globalException;
    }
}
