package com.xinwangdao.CompanyStatistical.component;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.google.common.base.Strings;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import javax.validation.constraints.Max;
import javax.validation.constraints.Min;
import java.util.Arrays;
import java.util.stream.Collectors;

/**
 * 通用分页查询Bean
 *
 * @Author: zthu
 * @Date: 2021-06-15
 */
@Data
@Accessors(chain = true)
@ApiModel(value = "QueryPage对象", description = "查询分页")
public class QueryPageBean {
    @ApiModelProperty("当前页码")
    @Min(1)
    private Integer current = 1;

    @ApiModelProperty("分页大小")
    @Max(100)
    @Min(1)
    private Integer size = 10;

    @ApiModelProperty("关键词")
    private String keyword;

    @ApiModelProperty("排序字段，例如：+id/-id")
    private String sort;

    public Page toPage() {
        Page page = new Page().setCurrent(current).setSize(size);
        if (!Strings.isNullOrEmpty(sort)) {
            String[] split = sort.split(",");
            page.setAscs(Arrays.asList(split));
        }
        return page;
    }
}
