package com.xinwangdao.CompanyStatistical.component;

import com.baomidou.mybatisplus.core.metadata.IPage;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.ToString;
import lombok.experimental.Accessors;

import java.util.List;

/**
 * 统一分页结果对象
 *
 * @Author: zthu
 * @Date: 2021-06-15
 */
@Data
@ToString
@Accessors(chain = true)
@ApiModel("统一分页对象")
public class ResultPageBean<T> {
    @ApiModelProperty("记录")
    private List<T> records;

    @ApiModelProperty("总记录数")
    private long total;

    @ApiModelProperty(value = "当前页码")
    private long current;

    @ApiModelProperty(value = "分页大小")
    private long size;

    public ResultPageBean(IPage<T> iPage){
        this.records=iPage.getRecords();
        this.total=iPage.getTotal();
        this.current=iPage.getCurrent();
        this.size=iPage.getSize();
    }
}
