package com.xinwangdao.CompanyStatistical.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.google.common.base.Strings;
import com.xinwangdao.CompanyStatistical.component.GlobalResponse;
import com.xinwangdao.CompanyStatistical.component.QueryPageBean;
import com.xinwangdao.CompanyStatistical.component.ResultPageBean;
import com.xinwangdao.CompanyStatistical.entity.DetailLog;
import com.xinwangdao.CompanyStatistical.entity.Project;
import com.xinwangdao.CompanyStatistical.entity.ProjectDetail;
import com.xinwangdao.CompanyStatistical.entity.SatisfactionLog;
import com.xinwangdao.CompanyStatistical.entity.dto.FormDetailDTO;
import com.xinwangdao.CompanyStatistical.service.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import static com.xinwangdao.CompanyStatistical.component.GlobalResponse.fail;
import static com.xinwangdao.CompanyStatistical.component.GlobalResponse.success;

/**
 *  前端控制器
 *
 * @Author: zthu
 * @Date: 2021-06-15
 */
@Api(description = "")
@Slf4j
@RestController
@RequestMapping("/api/admin/detail-log")
public class DetailLogController {
    @Autowired
    IDetailLogService detailLogService;

    @Autowired
    IProjectService projectService;

    @Autowired
    IProjectDetailService projectDetailService;

    @Autowired
    ISatisfactionLogService satisfactionLogService;

    @Autowired
    IProjectCompanyRelationService projectCompanyRelationService;

    @ApiOperation("根据id获取")
    @RequestMapping(value = "/{id}", method = RequestMethod.GET)
    public GlobalResponse<DetailLog> getOne(@PathVariable Integer id) {
        return success(detailLogService.getById(id));
    }

    @ApiOperation("新增")
    @RequestMapping(value = "", method = RequestMethod.POST)
    public GlobalResponse addOne(@RequestBody DetailLog entity) {
/*        Integer detailId = entity.getDetailId();
        ProjectDetail  projectDetail= projectDetailService.getById(detailId);
        QueryWrapper<ProjectDetail> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("project_id",projectDetail.getProjectId());

        List<ProjectDetail> list = projectDetailService.list(queryWrapper);
        Boolean flag = true;
        for(ProjectDetail pd : list){
            if(pd.getId().intValue() != projectDetail.getId().intValue()){
                if(3 == pd.getType()){
                    QueryWrapper<SatisfactionLog> satisfactionLogQueryWrapper = new QueryWrapper<>();
                    satisfactionLogQueryWrapper.eq("satisfaction_id",pd.getSatisfactionId()).eq("company_id",entity.getCompanyId()).eq("project_id",projectDetail.getProjectId());
                    SatisfactionLog satisfactionLog = satisfactionLogService.getOne(satisfactionLogQueryWrapper);
                    if(null == satisfactionLog){
                        flag = false;
                        break;
                    }
                }else {
                    QueryWrapper<DetailLog> detailLogQueryWrapper = new QueryWrapper<>();
                    detailLogQueryWrapper.eq("detail_id",pd.getId()).eq("company_id",entity.getCompanyId());
                    DetailLog detailLog = detailLogService.getOne(detailLogQueryWrapper);
                    if(null == detailLog){
                        flag = false;
                        break;
                    }
                }
            }
        }
        QueryWrapper<ProjectCompanyRelation> qw = new QueryWrapper<>();
        qw.eq("project_id",projectDetail.getProjectId()).eq("company_id",entity.getCompanyId());
        ProjectCompanyRelation one = projectCompanyRelationService.getOne(qw);
        if(flag){
            one.setStatus(2);
        }else {
            one.setStatus(1);
        }
        projectCompanyRelationService.updateById(one);*/
        ProjectDetail projectDetail = projectDetailService.getById(entity.getDetailId());
        Project project = projectService.getById(projectDetail.getProjectId());
        if(1 != project.getStatus()){
            return fail("项目已停用或已截至");
        }
        entity.setCreateTime(new Date());
        detailLogService.save(entity);

        return success(entity);
    }

    @ApiOperation("修改")
    @RequestMapping(value = "/{id}", method = RequestMethod.PUT)
    public GlobalResponse updateOne(@PathVariable Integer id,
                                                @RequestBody DetailLog entity) {
        DetailLog detailLog = detailLogService.getById(id);
        ProjectDetail projectDetail = projectDetailService.getById(detailLog.getDetailId());
        Project project = projectService.getById(projectDetail.getProjectId());
        if(1 != project.getStatus()){
            return fail("项目已停用或已截至");
        }
        detailLogService.updateById(entity.setId(id));
        return success(entity);
    }

    @ApiOperation("删除")
    @RequestMapping(value = "/{id}", method = RequestMethod.DELETE)
    public GlobalResponse deleteOne(@PathVariable Integer id) {
        detailLogService.removeById(id);
        return success();
    }

    @ApiOperation("列表查询")
    @RequestMapping(value = "", method = RequestMethod.GET)
    public GlobalResponse<ResultPageBean<DetailLog>> list(QueryPageBean queryBean) {
        IPage page = detailLogService.page(queryBean.toPage(), Wrappers.<DetailLog>lambdaQuery()
                .like(!Strings.isNullOrEmpty(queryBean.getKeyword()), DetailLog::getId, queryBean.getKeyword())
        );
        ResultPageBean<DetailLog> returnVal = new ResultPageBean(page);
        return success(returnVal);
    }

    @ApiOperation("查询企业已填表单")
    @RequestMapping(value = "/queryFormListForCompany", method = RequestMethod.GET)
    public GlobalResponse queryFormListForCompany(QueryPageBean queryBean,@RequestParam("projectId")Integer projectId,@RequestParam("companyId")Integer companyId,@RequestParam("logType")Integer logType) {
        QueryWrapper<ProjectDetail> queryWrapper = new QueryWrapper<>();
        if(2 == logType){
            queryWrapper.eq("project_id",projectId).eq("type",logType);
        }else {
            queryWrapper.eq("project_id",projectId).ne("type",2);
        }

        List<ProjectDetail> list = projectDetailService.list(queryWrapper);
        ArrayList<FormDetailDTO> resultList = new ArrayList<>();
        for(ProjectDetail projectDetail : list){
            FormDetailDTO formDetailDTO = new FormDetailDTO();
            formDetailDTO.setProjectDetail(projectDetail);
            if(3 == projectDetail.getType()){
                QueryWrapper<SatisfactionLog> satisfactionLogQueryWrapper = new QueryWrapper<>();
                satisfactionLogQueryWrapper.eq("satisfaction_id",projectDetail.getSatisfactionId()).eq("company_id",companyId).eq("project_id",projectDetail.getProjectId());
                SatisfactionLog satisfactionLog = satisfactionLogService.getOne(satisfactionLogQueryWrapper);
                formDetailDTO.setIsSatisfaction(true);
                if(null != satisfactionLog){
                    formDetailDTO.setLogId(satisfactionLog.getId());
                    formDetailDTO.setSatisfactionLog(satisfactionLog);
                    formDetailDTO.setIsFilled(true);
                }
            }else {
                QueryWrapper<DetailLog> detailLogQueryWrapper = new QueryWrapper<>();
                detailLogQueryWrapper.eq("detail_id",projectDetail.getId()).eq("company_id",companyId);
                DetailLog detailLog = detailLogService.getOne(detailLogQueryWrapper);
                if(null != detailLog){
                    formDetailDTO.setDetailLog(detailLog);
                    formDetailDTO.setLogId(detailLog.getId());
                    formDetailDTO.setIsFilled(true);
                }
            }

            resultList.add(formDetailDTO);
        }
        return success(resultList);
    }


}
