package com.xinwangdao.CompanyStatistical.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.util.Date;

/**
 * 
 *
 * @Author: zthu
 * @Date: 2021-06-15
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("`company`")
@ApiModel(value="Company对象", description="")
public class Company implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    @ApiModelProperty(value = "企业名称")
    @TableField("company_name")
    private String companyName;

    @ApiModelProperty(value = "单位性质")
    @TableField("company_unit")
    private String companyUnit;

    @ApiModelProperty(value = "营业执照号")
    @TableField("business_license_no")
    private String businessLicenseNo;

    @ApiModelProperty(value = "联系人")
    @TableField("linkman")
    private String linkman;

    @ApiModelProperty(value = "联系人手机号码")
    @TableField("link_phone")
    private String linkPhone;

    @ApiModelProperty(value = "用户id")
    @TableField("user_id")
    private Integer userId;

    @ApiModelProperty(value = "状态 1启用")
    @TableField("status")
    private Integer status;

    @ApiModelProperty(value = "创建时间")
    @TableField("create_time")
    private Date createTime;

    @ApiModelProperty(value = "更新时间")
    @TableField("update_time")
    private Date updateTime;

    @ApiModelProperty(value = "分类id字符串，以逗号分隔")
    @TableField("company_types")
    private String companyTypes;

    @ApiModelProperty(value = "最后登陆时间")
    @TableField("last_login_time")
    private Date lastLoginTime;

    @ApiModelProperty(value = "访问统计")
    @TableField("access_statistics")
    private Integer accessStatistics;

    @ApiModelProperty(value = "分类id字符串描述")
    @TableField("company_types_name")
    private String companyTypesName;
}
