package com.xinwangdao.CompanyStatistical.handler;

import com.xinwangdao.CompanyStatistical.component.GlobalException;
import com.xinwangdao.CompanyStatistical.component.GlobalResponse;
import lombok.extern.slf4j.Slf4j;
import org.springframework.core.annotation.Order;
import org.springframework.dao.DuplicateKeyException;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;

/**
 * @Author: zthu
 * @Date: 2021-06-15
 */
@Slf4j
@ControllerAdvice
@Order(4)
public class DBExceptionHandler {
    /**
     * @param ex
     * @return
     * @Valid 注解异常
     */
    @ResponseBody
    @ResponseStatus(HttpStatus.OK)
    @ExceptionHandler(DuplicateKeyException.class)
    public GlobalResponse DuplicateKeyExceptionHandler(DuplicateKeyException ex) {
        log.error("DuplicateKeyException catch => ", ex);
        return GlobalResponse.fail(GlobalException.DB_DUPLICATE_KEY);
    }
}
