package com.xinwangdao.CompanyStatistical.handler;

import com.xinwangdao.CompanyStatistical.component.GlobalException;
import com.xinwangdao.CompanyStatistical.component.GlobalResponse;
import lombok.extern.slf4j.Slf4j;
import org.springframework.core.annotation.Order;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;

/**
 * @Author: zthu
 * @Date: 2021-06-15
 */
@Slf4j
@ControllerAdvice
@Order(999)
public class UnknownExceptionHandler {
	@ResponseBody
    @ResponseStatus(HttpStatus.OK)
    @ExceptionHandler(GlobalException.GlobalRunTimeException.class)
    public GlobalResponse handlerException(GlobalException.GlobalRunTimeException ex) {
        log.error("GlobalRunTimeException catch => {}", ex.getGlobalException());
        return GlobalResponse.fail(ex.getGlobalException());
    }
	
    @ResponseBody
    @ResponseStatus(HttpStatus.OK)
    @ExceptionHandler(Exception.class)
    public GlobalResponse handlerException(Exception ex) {
        log.error("UnknownException catch => ", ex);
        return GlobalResponse.fail(GlobalException.UNKNOWN_ERROR);
    }
}
