package com.xinwangdao.CompanyStatistical.shiro;

import com.xinwangdao.CompanyStatistical.entity.User;
import com.xinwangdao.CompanyStatistical.service.ILoginService;
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authc.*;
import org.apache.shiro.authz.AuthorizationInfo;
import org.apache.shiro.authz.SimpleAuthorizationInfo;
import org.apache.shiro.realm.AuthorizingRealm;
import org.apache.shiro.subject.PrincipalCollection;
import org.apache.shiro.util.ByteSource;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Optional;

/**
 * @Author: zthu
 * @Date: 2021-06-15
 */
@Slf4j
@Service
public class UserRealm extends AuthorizingRealm {
    @Autowired
    ILoginService loginService;

    protected AuthenticationInfo doGetAuthenticationInfo(AuthenticationToken token) throws AuthenticationException {
        String name = token.getPrincipal().toString();
        Optional<User> optionalUser = loginService.findByName(name);
        User user = optionalUser.orElseThrow(() -> new UnknownAccountException());
        return new SimpleAuthenticationInfo(name,
                user.getPassword(),
                ByteSource.Util.bytes(user.getSalt()),
                getName()
        );
    }

    @Override
    protected AuthorizationInfo doGetAuthorizationInfo(PrincipalCollection principals) {
        SimpleAuthorizationInfo simpleAuthorizationInfo = new SimpleAuthorizationInfo();
        return simpleAuthorizationInfo;
    }
}

