package com.xinwangdao.CompanyStatistical.util;

import com.xinwangdao.CompanyStatistical.entity.dto.ExcelDTO;
import org.apache.poi.hssf.usermodel.*;

import java.util.List;

public class GenerateExcel {

    public static HSSFWorkbook exportExcelPaper(HSSFWorkbook workbook,List<String> titleList,List<ExcelDTO> list, String detailName) {

        // 标题
//        String[] title = { "序号", "企业名称", "表单名称", "表单内容"};
        // 创建一个工作簿

        // 创建一个工作表sheet
        HSSFSheet sheet = workbook.createSheet(detailName);
        // 设置列宽
        setColumnWidth(sheet, 8);
        // 创建第一行
        HSSFRow row = sheet.createRow(0);
        // 创建一个单元格
        HSSFCell cell = null;
        // 创建表头
        for (int i = 0; i < titleList.size(); i++) {
            cell = row.createCell(i);
            // 设置样式
            HSSFCellStyle cellStyle = workbook.createCellStyle();
//            cellStyle.setAlignment(HSSFCellStyle.ALIGN_CENTER); // 设置字体居中
            // 设置字体
            HSSFFont font = workbook.createFont();
            font.setFontName("宋体");
//            font.setBoldweight(HSSFFont.BOLDWEIGHT_BOLD);// 字体加粗
            // font.setFontHeight((short)12);
            font.setFontHeightInPoints((short) 13);
            cellStyle.setFont(font);
            cell.setCellStyle(cellStyle);

            cell.setCellValue(titleList.get(i));
        }

        // 从第二行开始追加数据
        for (int i = 1; i < (list.size() + 1); i++) {
            // 创建第i行
            HSSFRow nextRow = sheet.createRow(i);
            for (int j = 0; j < titleList.size(); j++) {
                ExcelDTO excelDTO = list.get(i-1);
                HSSFCell cell2 = nextRow.createCell(j);
                if (j == 0) {
                    cell2.setCellValue(i);
                }else if (j == 1) {
                    cell2.setCellValue(excelDTO.getCompanyName());
                }else {
                    cell2.setCellValue(excelDTO.getMap().get(titleList.get(j)));
                }


            }
        }

/*         创建一个文件
        File desktopDir = FileSystemView.getFileSystemView().getHomeDirectory();
        String desktopPath = desktopDir.getAbsolutePath();
        File file = new File(desktopPath+"/活动业主.xls");
        try {
            file.createNewFile();
            // 打开文件流
            FileOutputStream outputStream = FileUtils.openOutputStream(file);
            workbook.write(outputStream);
            outputStream.close();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }*/

/*        try {
            OutputStream output;
            //清空缓存
            response.reset();

            output = response.getOutputStream();

            //定义浏览器响应表头，顺带定义下载名，比如students(中文名需要转义)
            response.setHeader("Content-disposition", "attachment;filename="+new String(projectName.getBytes(),"iso-8859-1")+".xls");
            //定义下载的类型，标明是excel文件
            response.setContentType("application/vnd.ms-excel");
            //这时候把创建好的excel写入到输出流
            workbook.write(output);
            //养成好习惯，出门记得随手关门
            output.close();
        } catch (IOException e) {
            e.printStackTrace();
        }*/
        return workbook;
    }

    // 设置列宽()
    private static void setColumnWidth(HSSFSheet sheet, int colNum) {
        for (int i = 0; i < colNum; i++) {
            int v = 0;
            v = Math.round(Float.parseFloat("15.0") * 37F);
            v = Math.round(Float.parseFloat("20.0") * 267.5F);
            sheet.setColumnWidth(i, v);
        }
    }
}
