package com.xinwangdao.CompanyStatistical.util;

import com.google.common.io.ByteStreams;
import com.google.common.io.Files;
import lombok.SneakyThrows;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.PostConstruct;
import javax.validation.constraints.NotNull;
import java.io.File;

/**
 * @Author: zthu
 * @Date: 2019/10/21 16:50
 */
@Component
public class UploadUtil {
    @Value("${web.upload-path}")
    private String uploadPath;

    public static String uploadBasePath;

    @PostConstruct
    private void init() {
        uploadBasePath = uploadPath;
    }

    @SneakyThrows
    public static String upload(@NotNull MultipartFile file,String fileName,String projectId,String companyName) {
        String returnFileName = String.format("/%s/%s/%s.%s",
                projectId,
                companyName,
                fileName,Files.getFileExtension(file.getOriginalFilename()));
        if(returnFileName.endsWith(".")){
            returnFileName = returnFileName+"jpg";
        }
        File uploadFile = new File(uploadBasePath + returnFileName);
        Files.createParentDirs(uploadFile);
        Files.write(ByteStreams.toByteArray(file.getInputStream()), uploadFile);
//        file.transferTo(uploadFile);
        return "/upload" + returnFileName;
    }

    public static void main(String[] args) {
        String returnFileName = String.format("/%s/%s/%s.%s",
                "2",
                "65",
                "信息清单","xls");
        System.out.println(returnFileName);
    }
}
